%include	"linux.inc" 
%include	"record-def.inc" 

; Stack offsets of local variables 

ST_INPUT_DESCRIPTOR equ	-4 
ST_OUTPUT_DESCRIPTOR equ	-8 

		global	_start 

		section	.text 
_start: 

; Copy stack pointer and make room for local variables 

		mov	ebp,esp 
		sub	esp,8 

; Open file for reading 

		mov	ebx,input_file_name 
		mov	ecx,0 
		mov	edx,666q
		sys	Open
		mov	[ebp+ST_INPUT_DESCRIPTOR],eax 

; This will test and see if %eax is 
; negative. If it is not negative, it 
; will jump to continue_processing. 
; Otherwise it will handle the error 
; condition that the negative number 
; represents. 

		cmp	eax,0 
		jge	continue_processing 

; Send the error 

		section	.data 
no_open_file_code:
		db	"0001: ", 0 
no_open_file_msg: 
		db	"Can't Open Input File", 0 

		section	.text 
		push	no_open_file_msg 
		push	no_open_file_code 
		lcall	error_exit 
continue_processing: 

; Open file for writing 

		mov	ebx,output_file_name 
		mov	ecx,101q 
		mov	edx,666q
		sys	Open
		mov	[ebp+ST_OUTPUT_DESCRIPTOR],eax 

loop_begin:	push	dword[ebp+ST_INPUT_DESCRIPTOR] 
		push	record_buffer 
		lcall	read_record 
		add	esp,8 

; Returns the number of bytes read. 
; If it isn't the same number we 
; requested, then it's either an 
; end-of-file, or an error, so we're 
; quitting 

		cmp	eax,RECORD_size 
		jne	loop_end 

; Increment the age 

		inc	dword[record_buffer+RECORD.age] 

; Write the record out 

		push	dword[ebp+ST_OUTPUT_DESCRIPTOR] 
		push	record_buffer 
		lcall	write_record 
		add	esp,8 
		jmp	loop_begin 
loop_end: 
		xor	ebx,ebx
		sys	Exit

		section	.data 
input_file_name	db	"test.dat", 0 
output_file_name db	"testout.dat", 0 

;		section	.bss 
record_buffer	times	RECORD_size db 0 

