;; Time-stamp: <> -*-nasm-*-

%include  "linux.inc" 
%include  "record-def.inc" 

; Stack offsets of local variables 

ST_INPUT_DESCRIPTOR  equ -4 
ST_OUTPUT_DESCRIPTOR equ -8 

          global    _start 

          section   .text 

; Copy stack pointer and make room for local variables 

_start:   mov       ebp,esp 
          sub       esp,8 

; Open file for reading 

          mov       ebx,input_file_name 
          mov       ecx,0 
          mov       edx,666q
          sys       Open
          mov       [ebp+ST_INPUT_DESCRIPTOR],eax 

; Open file for writing 

          mov       ebx,output_file_name 
          mov       ecx,101q 
          mov       edx,666q
          sys       Open
          mov       [ebp+ST_OUTPUT_DESCRIPTOR],eax 

loop_begin:
          push      dword[ebp+ST_INPUT_DESCRIPTOR] 
          push      record_buffer 
          lcall     read_record 
          add       esp,8 

; Returns the number of bytes read. 
; If it isn't the same number we 
; requested, then it's either an 
; end-of-file, or an error, so we're 
; quitting 

          cmp       eax,RECORD_size 
          jne       loop_end 

; Increment the age 

          inc       dword[record_buffer+RECORD.age] 

; Write the record out 

          push      dword[ebp+ST_OUTPUT_DESCRIPTOR] 
          push      record_buffer 
          lcall     write_record 
          add       esp,8 
          jmp       loop_begin 
loop_end: 
          xor       ebx,ebx
          sys       Exit

          section   .data 
input_file_name	 db "test.dat", 0 
output_file_name db "testout.dat", 0 

;         section	.bss 
record_buffer times	RECORD_size db 0 
