;; Time-stamp: <> -*-nasm-*-
;; count-chars.asm: Count the characters until a null byte is reached. 
 
; Entry conditions: The address of the character string. 
; Exit conditions:  Returns the count in EAX. 
 
; Process: 
; Registers used:   ECX - character count 
;                   AL - current character 
;                   EDX - current character address 

          global    count_chars 

; This is where our one parameter is on the stack 

ST_STRING_START_ADDRESS equ 8 

count_chars:
          push      ebp 
          mov       ebp,esp 

; Counter starts at zero 

          mov       ecx,0 

; Starting address of data 

          mov       edx,[ebp+ST_STRING_START_ADDRESS] 
count_loop_begin: 

; Grab the current character 

          mov       al,[edx] 

; Is it null? 

          cmp       al,0 

; If yes, we're done 

          je        count_loop_end 

; Otherwise, increment the counter and the pointer 

          inc       ecx 
          inc       edx 

; Go back to the beginning of the loop 

          jmp       count_loop_begin 
count_loop_end: 

; We're done.  Move the count into EAX and return. 

          mov       eax,ecx 
          pop       ebp 
          ret	
