;; Time-stamp: <> -*-nasm-*-
;; This program finds the maximum number of a set of data items.
 
; VARIABLES: The registers have the following uses: 
 
; EDI = Index of the data item being examined.
; EBX = Largest data item found. 
; EAX = Current data item. 
 
; The following memory locations are used: 
 
; data_items - Contains the item data.  A 0 is used to terminate the
;              data. 

          global   _start
 
          section  .text 
_start:   xor       edi,edi       ; Move 0 into the index register.
          mov       eax,[data_items+edi*4]; Load the first byte of
                                  ;   data since this is the first
          mov       ebx,eax       ;   item, EAX is the biggest.

start_loop:
          test      eax,eax       ; Check to see if we've hit the
          jz        loop_exit     ;   end.
          add       edi,1         ; Load next value.
          mov       eax,[data_items+edi*4] 
          cmp       eax,ebx       ; Compare values.
          jle       start_loop    ; Jump to loop beginning if the new
                                  ;   one isn't bigger.
          mov       ebx,eax       ; Move the value as the largest.
          jmp       start_loop    ; Jump to loop beginning.
 
; EBX is the status code for the exit system call and it already has
; the maximum number

loop_exit:mov       eax,1         ; 1 is the exit() syscall.
          int       80h 

          section   .data 
data_items dd        3,67,34,222,45,75,54,34,44,33,22,11,66,0 
