;; Time-stamp: <> -*-nasm-*-

%include  "linux.inc" 
%include  "record-def.inc" 

          global    _start 

; Main program 

          section   .text 

; These are the locations on the stack where we will store the input
; and output descriptors (FYI - we could have used memory addresses in
; a .data section instead)

ST_INPUT_DESCRIPTOR  equ -4 
ST_OUTPUT_DESCRIPTOR equ -8 

; Copy the stack pointer to %ebp 

_start:   mov       ebp,esp 

; Allocate space to hold the file descriptors 

          sub       esp,8 

; Open the file 

          mov       ebx,file_name 
          mov       ecx,0         ; This says to open read-only 
          mov       edx,666q
          sys       Open

; Save file descriptor 

          mov       [ebp+ST_INPUT_DESCRIPTOR],eax 

; Even though it's a constant, we are saving the output file
; descriptor in a local variable so that if we later decide that it
; isn't always going to be STDOUT, we can change it easily.

          mov       dword[ebp+ST_OUTPUT_DESCRIPTOR],STDOUT 
record_read_loop: 
          push      dword[ebp+ST_INPUT_DESCRIPTOR] 
          push      record_buffer 
          lcall     read_record 
          add       esp,8 

; Returns the number of bytes read.  If it isn't the same number we
; requested, then it's either an end-of-file, or an error, so we're
; quitting

          cmp       eax,RECORD_size 
          jne       finished_reading 

; Otherwise, print out the first name but first, we must know it's
; size

          push      dword record_buffer+RECORD.firstname 
          lcall     count_chars 
          add       esp,4 
          mov       edx,eax 
          mov       ebx,[ebp+ST_OUTPUT_DESCRIPTOR] 
          mov       ecx,record_buffer+RECORD.firstname
          sys       Write
          push      dword[ebp+ST_OUTPUT_DESCRIPTOR] 
          lcall     write_newline 
          add       esp,4 
          jmp       record_read_loop 
finished_reading: 
          xor       ebx,ebx
          sys       Exit

          section   .data 
file_name db        "test.dat", 0 

;                   section   .bss 
record_buffer times RECORD_size db 0
