;; Time-stamp: <> -*-nasm-*-

%include  "linux.inc" 
%include  "record-def.inc" 

          global    _start 

; Copy the stack pointer to ebp 

_start:   mov       ebp,esp 

; Allocate space to hold the file descriptor 

          sub       esp,4 

ST_FILE_DESCRIPTOR equ	-4 

; Open the file 

          mov       ebx,file_name 
          mov       ecx,101q      ; This says to create if it doesn't
				  ;  exist, and open for writing.
          mov       edx,666q
          sys       Open

; Store the file descriptor away 

          mov       [ebp+ST_FILE_DESCRIPTOR],eax 

; Write the first record 

          push      dword[ebp+ST_FILE_DESCRIPTOR] 
          push      record1 
          lcall     write_record 
          add       esp,8 

; Write the second record 

          push      dword[ebp+ST_FILE_DESCRIPTOR] 
          push      record2 
          lcall     write_record 
          add       esp,8 

; Write the third record 

          push      dword[ebp+ST_FILE_DESCRIPTOR] 
          push      record3 
          lcall     write_record 
          add       esp,8 

; Close the file descriptor 

          mov       ebx,[ebp+ST_FILE_DESCRIPTOR]
          sys       Close

; Exit the program 

          xor       ebx,ebx
          sys       Exit

          section   .data 

; Constant data of the records we want to write Each text data item is
; padded to the proper length with null (i.e. 0) bytes.

; .rept is used to pad each item. .rept tells the assembler to repeat
; the section between .rept and .endr the number of times specified.
; This is used in this program to add extra null characters at the end
; of each field to fill it up

record1	  resb      0
istruc RECORD
at RECORD.firstname, db	"Fredrick", 0 
at RECORD.lastname,  db "Bartlett", 0 
at RECORD.address,   db	"4242 S Prairie", 10, "Tulsa, OK 55555", 0
at RECORD.age,       dd	45 
iend

record2   resb      0
istruc RECORD
at RECORD.firstname, db	"Marilyn", 0
at RECORD.lastname,  db	"Taylor", 0
at RECORD.address,   db	"2224 S Johannan St", 10, "Chicago, IL 12345", 0
at RECORD.age,       dd	29 
iend

record3   resb      0
istruc RECORD
at RECORD.firstname, db	"Derrick", 0
at RECORD.lastname,  db	"McIntire", 0
at RECORD.address,   db	"500 W Oakland", 10, "San Diego, CA 54321", 0
at RECORD.age,       dd	36 
iend

; This is the name of the file we will write to 

file_name db        "test.dat", 0 
